<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="红外辐射强度" prop="radiationIntensity">
        <el-input
          v-model="queryParams.radiationIntensity"
          placeholder="请输入红外辐射强度"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['data:infraredOut:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['data:infraredOut:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['data:infraredOut:remove']"
        >删除</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['data:infraredOut:export']"
        >导出</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infraredOutList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="对应流场输出编号" align="center" prop="flowFieldOutputID" />
      <el-table-column label="对应红外输入编号" align="center" prop="infraredInputID" />
      <el-table-column label="文件输出" align="center" prop="outputFilePath">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-download"
            @click="download(scope.row.outputFilePath)"
            v-hasPermi="['data:model:edit']"
          >{{ getFileName(scope.row.outputFilePath) }}
          </el-button>
        </template>
      </el-table-column>
      <el-table-column label="红外辐射强度" align="center" prop="radiationIntensity" />
      <el-table-column label="红外图像" align="center" prop="infraredImagePath">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-download"
            @click="download(scope.row.infraredImagePath)"
            v-hasPermi="['data:model:edit']">
            {{getFileName(scope.row.infraredImagePath)}}
          </el-button>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['data:infraredOut:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['data:infraredOut:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改红外输出对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="对应流场输出编号"  prop="flowFieldOutputID">
          <el-select v-model="form.flowFieldOutputID" placeholder="请输入对应流场输出编号">
            <el-option v-for="item in flowFieldOutputOption"
                       :key="item.id"
                       :label="item.name"
                       :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="对应红外输入编号"  prop="infraredInputID">
          <el-select v-model="form.infraredInputID" placeholder="请输入对应红外输入编号">
            <el-option v-for="item in infraredInputOption"
                       :key="item.id"
                       :label="item.name"
                       :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="文件输出" prop="outputFilePath">
          <file-upload v-model="form.outputFilePath" :fileType="fileType" :fileSize="100" :limit="1" />
        </el-form-item>
        <el-form-item label="红外辐射强度" prop="radiationIntensity">
          <el-input v-model="form.radiationIntensity" placeholder="请输入红外辐射强度" />
        </el-form-item>
        <el-form-item label="红外图像" prop="infraredImagePath">
          <file-upload v-model="form.infraredImagePath" :fileType="imageType" :fileSize="100" :limit="1"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listInfraredOut, getInfraredOut, delInfraredOut, addInfraredOut, updateInfraredOut } from "@/api/data/infraredOut";
import { getFlowFieldOutputID } from "@/api/data/flowOut";
import { getInfraredInputID }from "@/api/data/infraredIn";

export default {
  name: "InfraredOut",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 红外输出表格数据
      infraredOutList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        flowFieldOutputID:null,
        infraredInputID:null,
        outputFile: null,
        outputFilePath: null,
        radiationIntensity: null,
        infraredImage:null,
        infraredImagePath:null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        outputFilePath:[
          { required: true, message: "文件输出不能为空", trigger: "blur" }
        ],
        infraredImagePath:[
          { required: true, message: "文件输出不能为空", trigger: "blur" }
        ]
      },
      flowFieldOutputOption:[],
      infraredInputOption:[],
      fileType: ['dat', 'xls', 'jpg', 'png'],
      imageType:['jpg','png']
    };
  },
  created() {
    this.getList();
    this.getOption();
  },
  methods: {
    /** 查询红外输出列表 */
    getList() {
      this.loading = true;
      listInfraredOut(this.queryParams).then(response => {
        this.infraredOutList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        flowFieldOutputID:null,
        infraredInputID:null,
        outputFile: null,
        outputFilePath: null,
        radiationIntensity: null,
        infraredImage:null,
        infraredImagePath:null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加红外输出";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getInfraredOut(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改红外输出";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateInfraredOut(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInfraredOut(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除红外输出编号为"' + ids + '"的数据项？').then(function() {
        return delInfraredOut(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('data/infraredOut/export', {
        ...this.queryParams
      }, `infraredOut_${new Date().getTime()}.xlsx`)
    },
    getFileName(path) {
      if (!path) {
        return ''
      } else if (path.lastIndexOf("/") > -1) {
        const newName = path.slice(path.lastIndexOf("/") + 1)
        const names = newName.split(".")
        if ((names.size = 2) && (names[0].length > 19)) {
          return newName.substring(0, names[0].length - 19) + '.' + names[1]
        } else {
          return newName
        }
      } else {
        return '';
      }
    },
    download(path) {
      this.$download.resource(path);
    },
    getOption() {
      getFlowFieldOutputID().then(resp=>{this.flowFieldOutputOption=resp.data})
      getInfraredInputID().then(resp=>{this.infraredInputOption = resp.data})
    }
  }
};
</script>
